%define anolis_release 2
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Testing\\)

%global base_version 2.183

Name:           perl-Data-Dumper
Version:        2.184
Release:        %{anolis_release}%{?dist}
Summary:        Stringified perl data structures, suitable for printing and eval
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Data-Dumper
Source0:        https://cpan.metacpan.org/authors/id/N/NW/NWCLARK/Data-Dumper-%{base_version}.tar.gz
Patch0:         Data-Dumper-2.183-Upgrade-to-2.184.patch

BuildRequires:  coreutils findutils gcc make
BuildRequires:  perl-devel perl-generators perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Copy) perl(strict) perl(warnings)
%if !%{defined perl_bootstrap}
BuildRequires:  perl(B::Deparse) perl(bytes) perl(Carp) perl(constant)
BuildRequires:  perl(Exporter) perl(Scalar::Util) perl(XSLoader) perl(Config)
BuildRequires:  perl(if) perl(lib) perl(overload) perl(strict)
BuildRequires:  perl(Test::More) >= 0.98 perl(vars) perl(Encode)
%endif
Requires:       perl(B::Deparse) perl(bytes) perl(Scalar::Util) perl(XSLoader)

%{?perl_default_filter}

%description
Given a list of scalars or reference variables, writes out their contents
in perl syntax. The references can also be objects. The content of each
variable is output in a single Perl statement. Handles self-referential
structures correctly.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl(Encode)
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup -p1 -n Data-Dumper-%{base_version}

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -size 0 -delete
%{_fixperms} %{buildroot}/*

# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
%if !%{defined perl_bootstrap}
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test
%endif

%files
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/Data*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes Todo

%changelog
* Tue Apr 11 2023 Kaihao Bai <carlo.bai@linux.alibaba.com> - 2.184-2
- optimize spec

* Thu Feb 09 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.184-1
- remove versioned MODULE_COMPAT_ requires
- update to version 2.184

* Tue Feb 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.183-3
- rebuild with perl_bootstrap disabled

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.183-2
- rebuild with perl 5.36.0

* Fri Mar 11 2022 Renbo <rb01097748@alibaba-inc.com> - 2.183-1 
- Init for Anolis OS 23
